function findMinLexicographicalLCS(N1, N2, isEqual) {
    if (N1 <= 0 || N2 <= 0)
        return [];
    const dp = new Array(N1);
    for (let i = 0; i < N1; ++i)
        dp[i] = new Uint32Array(N2);
    dp[0][0] = isEqual(0, 0) ? 1 : 0;
    for (let i = 1; i < N1; ++i)
        dp[i][0] = dp[i - 1][0] | (isEqual(i, 0) ? 1 : 0);
    for (let j = 1; j < N2; ++j)
        dp[0][j] = dp[0][j - 1] | (isEqual(0, j) ? 1 : 0);
    for (let i = 1; i < N1; ++i) {
        for (let j = 1; j < N2; ++j) {
            dp[i][j] = isEqual(i, j) ? dp[i - 1][j - 1] + 1 : Math.max(dp[i][j - 1], dp[i - 1][j]);
        }
    }
    const pairs = [];
    for (let len = dp[N1 - 1][N2 - 1], i = N1 - 1; len > 0; --len) {
        for (let j = 0; j < N2; ++j) {
            if (dp[i][j] === len) {
                while (i >= 0 && dp[i][j] === len)
                    i -= 1;
                pairs.push([i + 1, j]);
                break;
            }
        }
    }
    return pairs.reverse();
}
function findLengthOfLCS(N1, N2, isEqual) {
    const dp = findLCSOfEveryRightPrefix(N1, N2, isEqual);
    return dp === null ? 0 : dp[N2 - 1];
}
function findLCSOfEveryRightPrefix(N1, N2, isEqual) {
    if (N1 <= 0 || N2 <= 0)
        return null;
    const dp = new Uint32Array(N2);
    for (let i = 0; i < N1; ++i) {
        for (let j = N2 - 1; j > 0; --j) {
            if (isEqual(i, j)) {
                const candidate = dp[j - 1] + 1;
                if (dp[j] < candidate)
                    dp[j] = candidate;
            }
        }
        if (isEqual(i, 0))
            dp[0] = 1;
        for (let j = 1, x = dp[0]; j < N2; ++j) {
            if (dp[j] < x)
                dp[j] = x;
            else
                x = dp[j];
        }
    }
    return dp;
}

export { findLCSOfEveryRightPrefix, findLengthOfLCS, findMinLexicographicalLCS };
